#!/usr/bin/python
#-*- coding: utf8 -*-
import os
import sys
import codecs
import types
import xlrd

def is_number(s):
    try:
        float(s)
        return True
    except ValueError:
        pass

    try:
        import unicodedata
        unicodedata.numeric(s)
        return True
    except (TypeError, ValueError):
        pass

    return False

for filename in os.listdir(os.path.split(os.path.realpath(__file__))[0]):
    if filename.endswith('.xlsx'):
        data = xlrd.open_workbook(filename)
        filename = filename.split(".")[0]
        targetFile = codecs.open(filename + ".lua","w","utf-8")
        targetFile.write("local " + filename + " = {}\n")
        for table in data.sheets():
            targetFile.write("\n" + filename + "." + table.name + " = {")
            nrows = table.nrows
            ncols = table.ncols
            keys = []
            for i in range(ncols):
                value = table.cell(1, i).value
                keys.append(str(value))
            r = 2
            if "id" in keys:
                idIndex = keys.index("id")
            else:
                idIndex = None
            while r < nrows :
                if idIndex != None:

                    if is_number(table.cell(r, idIndex).value) == True:
                        _idIndex = int(table.cell(r, idIndex).value)
                    else:
                        _idIndex = table.cell(r, idIndex).value

                    targetFile.write("\n" + " "*4 + "id_" + str(_idIndex) + " = {")
                else:
                    targetFile.write("\n" + " "*4 + "{")
                for c in range(ncols):
                    value = table.cell(r, c).value
                    if type(value) is types.UnicodeType:
                        if ";" in value:
                            targetFile.write(keys[c] + " = {")
                            for vv in value.split(";"):
                                targetFile.write("{" + vv + "},")
                            targetFile.write("},")
                        elif "," in value:
                            targetFile.write(keys[c] + " = {" + str(value) + "}, ")
                        else:
                            targetFile.write(keys[c] + " = '" + value + "', ")
                    elif value == "":
                        targetFile.write(keys[c] + " = 0, ")
                    else:
                        if value - int(value) > 0:
                            targetFile.write(keys[c] + " = " + str(value) + ", ")
                        else:
                            targetFile.write(keys[c] + " = " + str(int(value)) + ", ")
                targetFile.write("},")
                r += 1
            targetFile.write("\n}\n")
        targetFile.write("\nreturn " + filename)
        targetFile.close()